﻿using Infragistics.Controls.Grids;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            DataContext = new List<Data>
            {
                new Data { ID = 1, Name = "Item 1" },
                new Data { ID = 2, Name = "Item 2" },
                new Data { ID = 3, Name = "Item 3" },
            };
        }

        

        private void XamGrid_Loaded(object sender, RoutedEventArgs e)
        {
            FilterColumnSettings fcs = xamGrid1.Columns.DataColumns["ID"].FilterColumnSettings;
            fcs.RowFilterOperands.Add(new IntEquals() { Icon = Resources["EqualsIcon"] as DataTemplate });

            FilterColumnSettings fcs1 = xamGrid1.Columns.DataColumns["Name"].FilterColumnSettings;
            fcs1.RowFilterOperands.Add(new StringEquals() { Icon = Resources["EqualsIcon"] as DataTemplate });
        }
    }

    public class Data
    {
        public int ID { get; set; }
        public string Name { get; set; }
    }

    public class IntEquals : FilterOperand
    {
        protected override string DefaultDisplayName
        {
            get
            {
                return "Equals";
            }
        }

        public override bool RequiresFilteringInput
        {
            get
            {
                return true;
            }
        }

        // Create filter expression that returns all products whose id is greater than 5
        public override System.Linq.Expressions.Expression FilteringExpression(object value)
        {
            if (value == null || (value != null && string.IsNullOrEmpty(value.ToString())))
                return null;
            System.Linq.Expressions.Expression<Func<Data, bool>> expr = product => product != null && product.ID == (int)value;
            return expr;
        }
    }

    public class StringEquals : FilterOperand
    {
        protected override string DefaultDisplayName
        {
            get
            {
                return "Equals";
            }
        }

        public override bool RequiresFilteringInput
        {
            get
            {
                return true;
            }
        }

        // Create filter expression that returns all products whose id is greater than 5
        public override System.Linq.Expressions.Expression FilteringExpression(object value)
        {
            if (value == null || (value != null && string.IsNullOrEmpty(value.ToString())))
                return null;
            System.Linq.Expressions.Expression<Func<Data, bool>> expr = product => product != null && product.Name.Equals(value);
            return expr;
        }
    }

    public class UnboundConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            Random rnd = new Random();
            if (value != null)
            {
                return rnd.Next();
            }
            return null;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }


}
